function creation(action)
% Fichier de cration des configurations initiales du jeu de la vie
% Cdric Blaser, 16.03.2008
%
% Il n'est pas ncessaire de comprendre le fonctionnement de ce fichier. Il
% est mis  votre disposition pour faciliter la cration des configurations
% initiales du jeu de la vie.
%
% Fonctionnement: il suffit de lancer le fichier (fentre de commande ou
% Debug > Run ou F5) et de rpondre aux questions des botes de dialoges.
%
% Il faut videmment avoir d'abord complt la fonction 'game_of_life' pour
% pouvoir l'utiliser.

global M;

% Dfinition de l'action par dfaut:
if nargin == 0
    action = 'debut';
end

switch action
    case 'debut'
        % Saisie du nombre de lignes et de colonnes:
        lignes   = str2double(inputdlg('Combien de lignes?','Game of Life'));
        colonnes = str2double(inputdlg('Combien de colonnes?','Game of Life'));
        
        % Cration de la matrice vide:
        M = zeros(lignes,colonnes);
        
        % Fermeture d'une ventuelle fentre du mme type:
        close(findobj('tag','matrix_creation'))
        
        % Cration de la fentre:
        figure('tag','matrix_creation');
        
        % Cration d'une case blanche par lment de la matrice:
        hold on
        for i = 1:lignes
            for j = 1:colonnes
                fill([0 1 1 0]+j,[0 0 1 1]-i,'w','ButtonDownFcn','creation clic','UserData',[i j])
            end
        end
        hold off
        axis equal off
        
        % Cration du bouton start:
        uicontrol('String','Start','Callback','creation start')

    case 'clic'
        % Rcupration des coordonnes de la case clique:
        coords  = get(gco,'UserData');
        ligne   = coords(1);
        colonne = coords(2);
        
        % Changement de l'tat de l'cran et de la matrice:
        if(M(ligne,colonne) == 0)
            M(ligne,colonne) = 1;
            set(gco,'FaceColor','b');
        else
            M(ligne,colonne) = 0;
            set(gco,'FaceColor','w');
        end
        
    case 'start'
        % Saisie du nombre de gnrations:
        generations = str2double(inputdlg('Combien de gnrations?','Game of Life'));
         
        % Fermeture de la fentre:
        close(findobj('tag','matrix_creation'))
        
        % Lancement du script principal:
        game_of_life(M,generations);
end